/*
 *  functonobs.hpp
 *  Template
 *
 *  Created by increpare on 17/01/2009.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */

#include "boost/variant.hpp"
using namespace boost;

typedef  boost::variant< num, num*,bool* >  vnum;
	

class extract : public static_visitor<num>
{
public:
	num operator()(num & i) const
	{
		return i;
	}
	
	num operator()(num* & i) const
	{
		return *i;
	}

	num operator()(bool* & i) const
	{
		return (num)(*i);
	}
};

class Condition {
public:
	vnum i;
	vnum j;
	Condition(vnum _i, vnum _j):i(_i),j(_j){};
	Condition(const Condition& c)
	{
		i=c.i;
		j=c.j;
	};
};

class TruthCondition:public Condition {
public:
	TruthCondition(bool* i):Condition(0.5,i){};
};

class less_than {
public:
	less_than(Condition c) : i(c.i), j(c.j) {};
	bool operator()()
	{
		num t_i=apply_visitor(extract(),i);
		num t_j=apply_visitor(extract(),j);
	
		return (t_i<t_j);
	}
private:
	vnum i;
	vnum j;
};